<!--
 * @Descripttion: 当前组件信息
 * @version: 1.0.0
 * @Author: 无尘
 * @Date: 2019-03-20 14:36:37
 * @LastEditors: 无尘
 * @LastEditTime: 2020-12-01 15:05:55
 -->
<template>
  <div class="daily-set-wrap ">
    <div class="daily-set-content border-box">
      <div class="m-b-20">
        <div role="alert" class="el-alert el-alert--info">
          <i class="el-alert__icon el-icon-info"></i>
          <div class="el-alert__content">
            <span class="el-alert__title">仅统计近两年数据</span>
          </div>
        </div>
      </div>
      <div class="table-condition flex flex-space-between m-b-23">
        <div class="table-condition-left">
          <el-input placeholder="请输入门店名称" maxlength="50" v-model="conditionObj.searchInput" class="w-264 " style="width: 264px;" @keyup.native="value => toInput(value, conditionObj.searchInput)"> <i slot="prefix" class="el-input__icon el-icon-search"></i> </el-input>
          <gic-select-group :brandId="brandId" class="m-l-10" :width="213" :selectData="conditionObj.storeGroup" @checkGroupIds="checkGroupIds"> </gic-select-group>
          <el-date-picker class="m-l-10" v-model="conditionObj.dateRange" @change="changeDate" :editable="false" :value-format="'yyyy-MM-dd'" type="daterange" align="right" unlink-panels range-separator="至" start-placeholder="开始日期" end-placeholder="结束日期"> </el-date-picker>
        </div>
        <div class="table-condition-right">
          <el-button v-if="$getButtonLimit($buttonCode.multipleDelReport)" :limit-code="$buttonCode.multipleDelReport" type="danger" @click="multDel">批量删除</el-button>
          <el-button v-if="$getButtonLimit($buttonCode.exportReport)" :limit-code="$buttonCode.exportReport" type="primary" :loading="loadingBtn" @click="exportExcel">导出</el-button>
        </div>
      </div>
      <el-table class="select-table" ref="multipleTable" v-loading="loading" :data="tableData" tooltip-effect="dark" :style="{ width: '100%', minHeight: tableH }" @selection-change="handleSelectionChange">
        <el-table-column type="selection" width="45"> </el-table-column>
        <!-- <el-table-column width="25">
          <template #header >
            <el-dropdown style="line-height: 10px; padding: 0; margin-left: -15px; transform: translateY(4px); -webkit-transform: translateY(4px);" @command="handleCommand" placement="bottom-start">
              <span class="el-dropdown-link"><i class="iconfont-hb3 icongengduo"></i> </span>
              <el-dropdown-menu slot="dropdown">
                <el-dropdown-item command="0"><span :style="{ color: selectRadio == 0 ? '#2f54eb' : '#606266' }">选择当页</span></el-dropdown-item>
                <el-dropdown-item command="1"><span :style="{ color: selectRadio == 1 ? '#2f54eb' : '#606266' }">选择全部</span></el-dropdown-item>
              </el-dropdown-menu>
            </el-dropdown>
          </template>
          <template slot-scope="scope"> </template>
        </el-table-column> -->
        <el-table-column label="门店名称" width="120" show-overflow-tooltip>
          <template slot-scope="scope"
            ><div style="width: 100%; overflow:hidden;text-overflow: ellipsis;">{{ scope.row.storeName }}</div></template
          >
        </el-table-column>
        <el-table-column prop="" label="任务总数">
          <template slot-scope="scope">{{ scope.row.taskCount }}</template>
        </el-table-column>
        <el-table-column prop="" label="已完成(含放弃)" show-overflow-tooltip>
          <template slot-scope="scope">{{ scope.row.completedCount }}</template>
        </el-table-column>
        <el-table-column prop="" label="完成率(含放弃)" show-overflow-tooltip>
          <template slot-scope="scope">{{ scope.row.completedRate }}</template>
        </el-table-column>
        <el-table-column prop="" label="待完成" show-overflow-tooltip>
          <template slot-scope="scope">{{ scope.row.noCompletedCount }}</template>
        </el-table-column>
        <el-table-column prop="" label="逾期中" show-overflow-tooltip>
          <template slot-scope="scope">{{ scope.row.overdueCount }}</template>
        </el-table-column>
        <el-table-column label="操作" v-if="$getButtonLimit($buttonCode.reportDetail)">
          <template slot-scope="scope">
            <el-button v-if="$getButtonLimit($buttonCode.reportDetail)" :limit-code="$buttonCode.reportDetail" type="text" @click="toDetail(scope.$index, scope.row)">查看详情</el-button>
          </template>
        </el-table-column>
      </el-table>
      <div class="block common-wrap__page text-right m-t-24" v-if="tableData.length != 0">
        <dm-pagination background @size-change="handleSizeChange" @current-change="handleCurrentChange" :current-page="currentPage" :page-sizes="[20, 40, 60, 80]" :page-size="pageSize" layout="total, sizes, prev, pager, next, jumper" :total="total"> </dm-pagination>
      </div>
    </div>
    <multiple-del :showDialog="showDialog" :detailFlag="false" @hideDialog="hideDialog"> </multiple-del>
  </div>
</template>
<script>
import gicSelectGroup from '@/components/common/gic-select-group.vue';
import multipleDel from '@/components/app/cloudDaily/multiple-del.vue';
import { getRequest, postRequest, postExcel } from '@/api/api';
import { _debounce } from '@/common/js/public';
import showMsg from '@/common/js/showmsg';
import errMsg from '@/common/js/error';
export default {
  name: 'reviewed',
  props: {
    brandId: {
      type: String,
      default() {
        return '';
      }
    }
  },
  data() {
    return {
      activeName: 'first',
      tableH: window.screen.availHeight - 464 - 126,
      activeTab: '1',
      activeBrand: this.brandId, // 商户(品牌) id

      activeId: '1',
      showDialog: false,
      // 条件
      conditionObj: {
        searchInput: '',
        storeGroup: [],
        storeType: '',
        dateRange: []
      },
      loading: false,
      selectRadio: 0, // 选择当页/选择全部
      tableData: [
        // {
        //   storeName: '2016-05-03',
        //   taskCount: '王小虎',
        //   completed: '10',
        //   completionRate: '10',
        //   unCompleted: '10',
        //   overdue: '1',
        //   taskId: '123',
        //   storeId: '123456',
        //   address: '上海市普陀区金沙江路 1518 弄'
        // }
      ],
      multipleSelection: [],
      // 分页参数
      currentPage: 1,
      pageSize: 20,
      total: 0,

      // 门店选择
      defaultStoreList: [],

      loadingBtn: false
    };
  },
  computed: {},
  methods: {
    /**
     * 选择门店分组
     */
    checkGroupIds: function(nodes) {
      const that = this;
      that.conditionObj.storeGroup = nodes;
      that.currentPage = 1;
      that.getTableList();
    },
    /**
     * 显示选择本页/全部
     */
    handleCommand(command) {
      this.selectRadio = command;
    },
    /**
     * 返回 的 brandId
     */
    setSelectTab(item) {
      let that = this;
      that.activeTab = item.tabId;
    },

    /**
     * 输入
     */
    toInput: _debounce(function(e, value) {
      let that = this;
      that.currentPage = 1;
      that.getTableList();
    }, 500),

    /**
     * 门店类型
     */
    changeStoreType() {
      let that = this;
      that.currentPage = 1;
      that.getTableList();
    },

    /**
     * 日期
     */
    changeDate(e) {
      let that = this;
      if (!e) {
        that.conditionObj.dateRange = [];
      }
      that.currentPage = 1;
      that.getTableList();
    },

    /**
     * 表格选择
     */
    handleSelectionChange(val) {
      this.multipleSelection = val;
    },

    /**
     * 删除选的部门
     */
    delDepart(index, item) {
      let that = this;
      item.splice(index, 1);
      that.currentPage = 1;
      that.defaultStoreList = that.conditionObj.storeGroup;
      that.getTableList();
    },

    /**
     * 批量删除
     */
    multDel() {
      let that = this;
      if (!that.multipleSelection.length) {
        that.$message.error({
          duration: 1000,
          message: '请选择删除项'
        });
        return false;
      }
      that.showDialog = true;
    },

    /**
     * 批量删除---弹窗关闭
     */
    hideDialog(obj) {
      let that = this;
      that.showDialog = false;
      if (!Object.keys(obj).length) {
        return false;
      }
      that.postMultDel(obj);
    },

    postMultDel(obj) {
      let that = this;
      let storeGroups = [];
      that.conditionObj.storeGroup.forEach(ele => {
        storeGroups.push(ele.storeGroupId);
      });
      if (!that.conditionObj.dateRange) {
        that.conditionObj.dateRange = [];
      }
      let para = {
        search: that.conditionObj.searchInput || '', // 搜索字段
        storeIds: that.multipleSelection.map(ele => ele.storeId).join(',') || '', // 门店
        storeGroupIds: storeGroups.join(',') || '', // 门店分组,数组
        storeType: that.conditionObj.storeType || '', //门店类型
        startDate: that.conditionObj.dateRange[0] || '',
        endDate: that.conditionObj.dateRange[1] || '',
        enterpriseId: that.activeBrand, // 品牌 id
        delOptFlag: obj.delOptFlag, // 0:仅删除逾期任务，1:删除所有待完成任务
        reason: obj.reason, // 备注
        chooseAllFlag: that.selectRadio // 0：当页，1：所有
      };
      postRequest('/haoban-app-daily-three-web/daily/batch-delete-brand-task', para)
        .then(res => {
          let resData = res.data;
          if (resData.errorCode == 1) {
            showMsg.showmsg('删除成功', 'success');
            that.getTableList();
            return;
          }
          errMsg.errorMsg(resData);
        })
        .catch(function(error) {
          that.$message.error({
            duration: 1000,
            message: error.message
          });
        });
    },

    /**
     * 导出
     */
    exportExcel: _debounce(function() {
      const that = this;
      that.loadingBtn = true;
      let storeGroups = [];
      that.conditionObj.storeGroup.forEach(ele => {
        storeGroups.push(ele.storeGroupId);
      });
      if (!that.conditionObj.dateRange) {
        that.conditionObj.dateRange = [];
      }
      let para = {
        search: that.conditionObj.searchInput || '', // 搜索字段
        storeGroupIds: storeGroups.join(',') || '', // 门店分组,数组
        storeType: that.conditionObj.storeType || '', //门店类型
        startDate: that.conditionObj.dateRange[0] || '',
        endDate: that.conditionObj.dateRange[1] || '',
        /* currentPage: that.currentPage, // 当前页
            pageSize: that.pageSize, // 一页显示个数 */
        enterpriseId: that.activeBrand // 品牌 id
      };
      /* let urlSource = `search=${para.search}&filterStoreIds=${para.filterStoreIds}&storeGroupIds=${para.storeGroupIds}&storeType=${para.storeType}&startDate=${para.startDate}&endDate=${para.endDate}&brandId=${para.brandId}&currentPage=${para.currentPage}&pageSize=${para.pageSize}`;
          window.open(`${window.location.origin}/haoban-app-daily-three-web/daily/batch-export-brand-task?${urlSource}`); */
      postExcel('/haoban-app-daily-three-web/daily/batch-export-brand-task', para)
        .then(res => {
          that.loadingBtn = false;
          if (!res.data) {
            errMsg.errorMsg('暂无数据');
            return false;
          }
          // let resData = res.data;
          const blob = new Blob([res.data], {
            type: 'application/vnd.ms-excel'
          });
          const fileName = `云日报记录.csv`;
          const elink = document.createElement('a');
          elink.download = fileName;
          elink.style.display = 'none';
          elink.href = URL.createObjectURL(blob);
          document.body.appendChild(elink);
          elink.click();
          URL.revokeObjectURL(elink.href); // 释放URL 对象
          document.body.removeChild(elink);
          // errMsg.errorMsg(resData);
        })
        .catch(function(error) {
          that.loadingBtn = false;
          that.$message.error({
            duration: 1000,
            message: error.message
          });
        });
    }, 300),

    /**
     * 分页---页码变化
     *  @param {Number} val
     */
    handleSizeChange(val) {
      const that = this;
      that.currentPage = 1;
      that.pageSize = val;
      that.getTableList();
    },

    /**
     * 分页---当前页变化
     *  @param {Number} val
     */
    handleCurrentChange(val) {
      const that = this;
      that.currentPage = val;
      // let fullPath = that.$route.fullPath;
      that.getTableList();
    },

    /**
     * 查看详情
     */
    toDetail(index, row) {
      let that = this;
      that.$router.push(`dailyDetail?storeId=${row.storeId}`);
    },

    /**
     * 获取列表数据
     */
    getTableList(val) {
      const that = this;
      that.loading = true;
      let storeGroups = [];
      that.conditionObj.storeGroup.forEach(ele => {
        storeGroups.push(ele.storeGroupId);
      });
      if (!that.conditionObj.dateRange) {
        that.conditionObj.dateRange = [];
      }
      let para = {
        search: that.conditionObj.searchInput || '', // 搜索字段
        storeGroupIds: storeGroups.join(',') || '', // 门店分组,分组
        storeType: that.conditionObj.storeType || '', //门店类型
        startDate: that.conditionObj.dateRange[0] || '',
        endDate: that.conditionObj.dateRange[1] || '',
        currentPage: that.currentPage, // 当前页
        pageSize: that.pageSize, // 一页显示个数
        enterpriseId: that.activeBrand
      };
      getRequest('/haoban-app-daily-three-web/daily/page-brand-task', para)
        .then(res => {
          let resData = res.data;
          that.loading = false;
          if (resData.errorCode == 1) {
            that.tableData = resData.result.result || [];
            that.total = resData.result.totalCount;
            return false;
          }
          errMsg.errorMsg(resData);
        })
        .catch(function(error) {
          that.loading = false;
          that.$message.error({
            duration: 1000,
            message: error.message
          });
        });
    }
  },
  watch: {
    brandId: function(newData, oldData) {
      let that = this;
      if (!!newData) {
        that.activeBrand = newData;
        that.getTableList();
      }
    }
  },
  mounted() {
    let that = this;
    that.activeBrand = that.brandId;
    if (!!that.brandId) {
      that.getTableList();
    }
    let start = new Date();
    start = new Date(start.setMonth(start.getMonth() - 3));
    const end = new Date();
    const startDate = [];
    const endDate = [];
    startDate.push(start.getFullYear());
    startDate.push((start.getMonth() + 1).toString().padStart(2, '0'));
    startDate.push(
      start
        .getDate()
        .toString()
        .padStart(2, '0')
    );
    endDate.push(end.getFullYear());
    endDate.push((end.getMonth() + 1).toString().padStart(2, '0'));
    endDate.push(
      end
        .getDate()
        .toString()
        .padStart(2, '0')
    );
    this.conditionObj.dateRange = [startDate.join('-'), endDate.join('-')];
  },
  components: {
    multipleDel,
    gicSelectGroup
  }
};
</script>
<style type="text/scss" lang="scss" scoped>
.color-c0c4cc {
  display: inline-block;
  line-height: 34px;
  padding-left: 10px;
  color: #c0c4cc;
}
.el-alert--info {
  width: 747px;
  font-size: 14px;
  color: #606266;
  background: rgba(240, 245, 255, 1);
  border-radius: 2px;
  border: 1px solid rgba(133, 165, 255, 1);
  .el-icon-info {
    width: 12px;
    font-size: 12px;
    color: #2f54eb;
  }
}

.daily-set-wrap {
  .daily-set-content {
    padding: 20px;
    box-sizing: border-box;
    .table-condition-left {
      font-size: 0;
    }
  }
  .depart-item-content {
    width: 213px;
    height: 32px;
    overflow: hidden;
    white-space: nowrap;
    border-radius: 4px;
    border: 1px solid #dcdfe6;
    cursor: pointer;
  }
  .item-cell-select {
    >>> .el-select__tags {
      white-space: nowrap;
      overflow: hidden;
    }
  }
  .depart-cell {
    position: relative;
    margin: 0 24px 24px 0;
    .el-icon-circle-close {
      position: absolute;
      top: -10px;
      right: -10px;
      font-size: 16px;
      color: #808995;
      cursor: pointer;
    }
  }
}
</style>
